var gGBSPopMgr = null;

var gGBSObserver = {
  owner: null,
  observe: function(aSubject, aTopic, aData){
    if(aTopic == "get-before-send"){
			// if offline, prompt for getting messages
			if (this.owner.goOnlineToPopMail()) this.owner.popMail(aData);
			else this.owner.notifyPOP(aData, false);
		}
  },
  register: function(owner) {
  	this.owner = owner;
  }
};


//class GBSUrlListener
function GBSUrlListener(popId, owner)
{
	this.popId = popId;
	this.owner = owner;
}

GBSUrlListener.prototype.OnStartRunningUrl = function(url)
{
}

GBSUrlListener.prototype.OnStopRunningUrl = function(url,exitCode)
{
	if (exitCode == 0) {
		this.owner.notifyPOP(this.popId, true);
	} else {
		if (this.owner.idsForUnsentMsgs && this.owner.idsForUnsentMsgs.errtype != "cancel")
		  this.owner.idsForUnsentMsgs.errtype = "error";
		this.owner.notifyPOP(this.popId, false);
	}
}

function initGBS()
{
	gGBSPopMgr = new GBSPopManager();
	gGBSObserver.register(gGBSPopMgr);
	var GBSObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	GBSObserverService.addObserver(gGBSObserver, "get-before-send", false);
}

window.addEventListener("load",initGBS,false);

function GBSPopManager()
{
	this.idsForUnsentMsgs = null;
	this.accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
	this.smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
	this.sendingUnsentMsgs = false;
	
	var def_skey = "VK_RETURN";
	var def_mod = [false, false, false, false, true]; //[accel, alt, ctrl, meta, shift]
	this.setShortcutKey("key_getsend","gbs.unsent_",def_skey,def_mod);
	var me = this;
	var menuInitFunc = function() {
		me.initSendUnsentMenu();
	}
	document.getElementById("menu_FilePopup").addEventListener("popupshowing",menuInitFunc,false);
}

GBSPopManager.prototype.goOnlineToSendUnsentMessages = function()
{
	var goOnline;
	if (MailOfflineMgr.isOnline()) return true;
	const nsIPS = Components.interfaces.nsIPromptService;
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(nsIPS);

	var offlineLabel = "";
	try {
		offlineLabel = MailOfflineMgr.offlineBundle.getString('sendMessagesOfflineLabel1'); 
	} catch(e) {
		//TB2.0b2 cannot get 'sendMessagesOfflineLabel1'. It seems bug of TB2.0b2.
		offlineLabel = MailOfflineMgr.offlineBundle.getString('sendMessagesOfflineLabel');
	}
	
	var goOnlineToSendMsgs = promptService.confirm(
		window,
		MailOfflineMgr.offlineBundle.getString('sendMessagesOfflineWindowTitle1'),
		offlineLabel);

	if (goOnlineToSendMsgs)
	  MailOfflineMgr.offlineManager.goOnline(
		  false /* send unsent messages*/, false, msgWindow);

	return goOnlineToSendMsgs;
}

GBSPopManager.prototype.msgSendUnsentMessages = function()
{
	// if offline, prompt for sendUnsentMessages
	if (this.goOnlineToSendUnsentMessages())
	  this.sendUnsentMessages();
}

GBSPopManager.prototype.sendUnsentMessages = function()
{
	//cancel reception
	//if (document.getElementById("menu_get-sendunsentmsgs").getAttribute("disabled") == "true") {
	if (this.sendingUnsentMsgs) {
	//goDoCommand('cmd_stop');
		try {
			this.idsForUnsentMsgs.errtype = "cancel";
		} catch(e) {
			dump(e);
		}
		return;
	}

	//get messages then send unsent messages
	var msgSendlater = Components.classes["@mozilla.org/messengercompose/sendlater;1"]
	  .getService(Components.interfaces.nsIMsgSendLater);
	var accountToBeChecked = new Array();
	var unsentMsgsExist = false;
	
	var allIdentities = this.accountManager.allIdentities;
	var identitiesCount = allIdentities.Count();

	for (var i = 0; i < identitiesCount; i++) {
		var currentIdentity = allIdentities.QueryElementAt(i, Components.interfaces.nsIMsgIdentity);
		
		var msgFolder = msgSendlater.getUnsentMessagesFolder(currentIdentity);
		if(!msgFolder) continue;

		var numMessages = msgFolder.getTotalMessages(false);
		if (numMessages == 0) continue;
		else unsentMsgsExist = true;

		//get auth account for currentIdentity
		var accountKey = this.getAuthIncomingServerAccount(currentIdentity.key);
		if (accountKey == "none") continue; //reception is not needed.
		else if (accountKey == "default") accountKey = this.getAccountKeyForIdKey(currentIdentity.key);

		//find message which use currentIdentity
		//var msgs = msgFolder.getMessages(msgWindow); //TB2?
		var msgs = msgFolder.msgDatabase.EnumerateMessages(); //TB3
		while (msgs.hasMoreElements()) {
			var msgHdr = msgs.getNext();
			msgHdr.QueryInterface(Components.interfaces.nsIMsgDBHdr);
			var idKey = this.getIdentityKeyFromMsgHeader(msgHdr);
			if (idKey == currentIdentity.key) { //message for currentIdentity is found.
				this.uniquePush(accountToBeChecked,accountKey);
				break;
			}
		}
	}

	if (!unsentMsgsExist) return; //no unsent messages
	this.startGetting(accountToBeChecked);
}

GBSPopManager.prototype.getIdentityKeyFromMsgHeader = function(msgHdr)
{
	var offset = msgHdr.messageOffset;
	//TB2
	//var msgPath = msgHdr.folder.path.nativePath;
	//var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	//localFile.initWithPath(msgPath);

	var localFile = msgHdr.folder.filePath; //TB3
	var fileInputStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	fileInputStream.init( localFile, 0x01, 0444, null ); // read
	fileInputStream.QueryInterface(Components.interfaces.nsISeekableStream);
	fileInputStream.seek(0,offset);
	fileInputStream.QueryInterface(Components.interfaces.nsILineInputStream);
	var line = {};
	var idKey = "";
	while (fileInputStream.readLine(line)) {
		var str = line.value;
		if (str == "") break; //End of header
		if (str.match(/X-Identity-Key: (id\d+)/)) {
			idKey = RegExp.$1;
			break;
		} else {
			continue;
		}
	}
	fileInputStream.close();

	return idKey;
}

GBSPopManager.prototype.getAccountKeyForIdKey = function(idKey)
{
	var id = this.accountManager.getIdentity(idKey);
	var servers = this.accountManager.GetServersForIdentity(id);
	var server = servers.QueryElementAt(0, Components.interfaces.nsIMsgIncomingServer);
	var account = this.accountManager.FindAccountForServer(server);
	return account.key;
}

GBSPopManager.prototype.getAuthIncomingServerAccount = function(idKey)
{
	var id = this.accountManager.getIdentity(idKey);
	var smtpServerKey = id.smtpServerKey;
	if (smtpServerKey == "")
	  smtpServerKey = this.smtpService.defaultServer.key;

	var prefString = "mail.smtpserver."+smtpServerKey+".gbs_inserver";
	var accountKey = nsPreferences.copyUnicharPref(prefString,"default");
	if (accountKey == "") accountKey = "default";

	return accountKey;
}

GBSPopManager.prototype.startGetting = function(accountToBeChecked)
{
	document.getElementById("menu_get-sendunsentmsgs").setAttribute("disabled","true");
	document.getElementById("menu_get-sendunsentmsgs-stop").setAttribute("disabled","false");
  this.sendingUnsentMsgs = true;
  
  var gbsButton = document.getElementById("button-getsend-unsent");
	if (gbsButton) {
		gbsButton.setAttribute("stat","get");
	}

	this.idsForUnsentMsgs = new Array();
	this.idsForUnsentMsgs.errtype = "none";
	for (var i in accountToBeChecked) {
		var date = new Date();
		var timeId = ("unsent" + date.getTime()).toString() + i + "." + accountToBeChecked[i];
		this.idsForUnsentMsgs.push(timeId);
		this.popMail(timeId);
	}
}

GBSPopManager.prototype.finalizeGetting = function()
{
	this.sendingUnsentMsgs = false;
	document.getElementById("menu_get-sendunsentmsgs").setAttribute("disabled","false");
	document.getElementById("menu_get-sendunsentmsgs-stop").setAttribute("disabled","true");

	var strId = "";
	if (this.idsForUnsentMsgs.errtype == "cancel") strId = "getsend.messengerstatus_canceled";
	else if (this.idsForUnsentMsgs.errtype == "error") strId = "getsend.getfail";
	else strId = "getsend.getpass";
	var localeBundle = document.getElementById("GBSBundle");
	var statusString = localeBundle.getString(strId);
	document.getElementById("statusText").setAttribute("label",statusString);
	
	this.idsForUnsentMsgs = null;
	var gbsButton = document.getElementById("button-getsend-unsent");
	if (gbsButton) {
		gbsButton.setAttribute("stat","init");
	}
}

GBSPopManager.prototype.hasElementForArray = function(array, data)
{
	for (var i in array) {
		if (array[i] == data) return true;
	}

	return false;
}

GBSPopManager.prototype.uniquePush = function(array, data)
{
	if (!this.hasElementForArray(array, data)) array.push(data);
}


GBSPopManager.prototype.goOnlineToPopMail = function()
{
	var goOnline;
	if (MailOfflineMgr.isOnline()) return true; //already online
	
	const nsIPS = Components.interfaces.nsIPromptService;
	var promptService =
	  Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(nsIPS);
	goOnline =  promptService.confirm(
		window,
		MailOfflineMgr.offlineBundle.getString('getMessagesOfflineWindowTitle1'), 
		MailOfflineMgr.offlineBundle.getString('getMessagesOfflineLabel1'));
	MailOfflineMgr.offlineManager.goOnline(
		false, false /* playbackOfflineImapOperations */, msgWindow);

	return goOnline;
}

GBSPopManager.prototype.popMail = function(popId)
{
	if (!popId) return;
	
	var listener = new GBSUrlListener(popId, this);
	var idParts = popId.split('.');
//	var gettingId = popId.split('.');
	var gettingId = new Array();
	gettingId.push(idParts.shift());
	gettingId.push(idParts.join('.'));
	var server = null;
	try {
		if (gettingId[1].search(/^id/) != -1) { //Get mails for Identity
			var id = this.accountManager.getIdentity(gettingId[1]);
			var servers = this.accountManager.GetServersForIdentity(id);
			server = servers.QueryElementAt(0, Components.interfaces.nsIMsgIncomingServer);
		} else if (gettingId[1].search(/^mailbox:/) != -1) { //Get mails for POP3 Account
			server = this.getServer(gettingId[1]);
		} else if (gettingId[1].search(/^imap:/) != -1) { //Get mails for IMAP Account
			server = this.getServer(gettingId[1]);
		} else if (gettingId[1].search(/^account\d+/) != -1) { //Get mails for Account Key
			var account = this.accountManager.getAccount(gettingId[1]);
			server = account.incomingServer;
		} else {
			this.notifyPOP(popId,false);
			return;
		}
		
		var checkOnly = false;
		try {
			var pref =  Components.classes["@mozilla.org/preferences-service;1"]
			  .getService(Components.interfaces.nsIPrefBranch);
			checkOnly = pref.getBoolPref("gbs.check_only");
		} catch(e) {
			checkOnly = false;
		}

		var inboxFolder = GetInboxFolder(server);
		if (!inboxFolder) inboxFolder = server.rootFolder;
		if (server.serverBusy) { //wait until the server is idle
			var me = this;
			var popFunc = function() {
				me.popMail(popId);
			}
			setTimeout(popFunc, 1000);
			return;
		}

		if (server.type == "pop3") {
			var pop3srv = Components.classes["@mozilla.org/messenger/popservice;1"]
			  .getService(Components.interfaces.nsIPop3Service);
			var pop3Server = server.QueryInterface(Components.interfaces.nsIPop3IncomingServer);
			
			if (checkOnly) {
				pop3srv.CheckForNewMail(msgWindow, listener, inboxFolder, pop3Server);
			} else {
			  pop3srv.GetNewMail(msgWindow, listener, inboxFolder, pop3Server);
			}
		} else if (server.type == "imap") {
			server.getNewMessages(inboxFolder, msgWindow,listener);
		}
	} catch(e) {
		this.notifyPOP(popId, false);
		dump("POP bofore SMTP ERROR" + e + "\n");
	}
}

GBSPopManager.prototype.getServer = function(uri)
{
    if (!uri) return null;
    try {
        var folder = GetMsgFolderFromUri(uri, true);
        return folder.server;
    }
    catch (ex) {
        dump("GetServer("+uri+") failed, ex="+ex+"\n");
    }
    return null;
}

GBSPopManager.prototype.notifyPOP = function(popId, succeed)
{
	var notify = popId.search(/^unsent/) == -1;
	var pref =  Components.classes["@mozilla.org/preferences-service;1"]
				  .getService(Components.interfaces.nsIPrefBranch);
	if (!notify && this.idsForUnsentMsgs) {
		for (var i=0; i<this.idsForUnsentMsgs.length; i++) {
			if (this.idsForUnsentMsgs[i] == popId) {
				this.idsForUnsentMsgs.splice(i,1);
				notify = false;
			}
		}
		if (this.idsForUnsentMsgs.length == 0) {
			var errtype = this.idsForUnsentMsgs.errtype;
			this.finalizeGetting();
			var send = false;
			switch (errtype) {
			  case "cancel":
				send = false;
				break;
			  case "error":
				try {
					send = pref.getBoolPref("gbs.send_on_err");
				} catch(e) {
					send = false;
				}
				break;
			  case "none":
				send = true;
				break;
			  default:
				send = true;
				break;
			}
			if (send) {
				var delay = 0;
				try {
					delay = pref.getIntPref("gbs.delay_sec");
				} catch(e) {
					delay = 0;
				}
				var func = function() {
					goDoCommand('cmd_sendUnsentMsgs');
				}
				setTimeout(func, delay*1000);
			}
		}
	}

	if (notify) { //notify to composer
		var observerService = Components.classes["@mozilla.org/observer-service;1"]
		  .getService(Components.interfaces.nsIObserverService);
		var topic = succeed ? "poped" : "pop-failed";
		observerService.notifyObservers(null, topic, popId);
	}
}


GBSPopManager.prototype.initSendUnsentMenu = function()
{
	var enabled = IsSendUnsentMsgsEnabled(null);
	if (enabled)
	  document.getElementById("menu_get-sendunsentmsgs").removeAttribute("disabled");
	else
	  document.getElementById("menu_get-sendunsentmsgs").setAttribute("disabled","true");
}

GBSPopManager.prototype.setShortcutKey = function(keyId, prefix, def_skey, def_mod)
{
	var modifiers = new Array();
	var pref =  Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	try {
		if (pref.getBoolPref(prefix + 'accel_key'))
		  modifiers.push('accel');
	} catch(e) {
		if (def_mod[0]) modifiers.push('accel');
	}

	try {
		if (pref.getBoolPref(prefix + 'alt_key'))
		  modifiers.push('alt');
	} catch(e) {
		if (def_mod[1]) modifiers.push('alt');
	}

	try {
		if (pref.getBoolPref(prefix + 'ctrl_key'))
		  modifiers.push('control');
	} catch(e) {
		if (def_mod[2]) modifiers.push('control');
	}

	try {
		if (pref.getBoolPref(prefix + 'meta_key'))
		  modifiers.push('meta');
	} catch(e) {
		if (def_mod[3]) modifiers.push('meta');
	}

	try {
		if (pref.getBoolPref(prefix + 'shift_key'))
		  modifiers.push('shift');
	} catch(e) {
		if (def_mod[4]) modifiers.push('shift');
	}

	var modifierString = null;
	if (modifiers.length > 0 ) modifierString = modifiers.join(' ');

	var skey;
	try {
		skey = pref.getCharPref(prefix + 'key');
	} catch(e) {
		skey = def_skey;
	}

	if (modifierString)
	  document.getElementById(keyId).setAttribute('modifiers', modifierString);
	var keyAttr = 'key';
	if (skey.indexOf("VK_") == 0) keyAttr = 'keycode';
	document.getElementById(keyId).setAttribute(keyAttr, skey);
}


