var gGBSSendMgr = null;

var gGBSPOPObserver = {
  localeBundle: null,
  ids: null,
  cmd: null,
  owner: null,
  register: function(owner) {
  	this.owner = owner;
  },
  
  observe: function(aSubject, aTopic, aData){
	  if (aData != this.ids) return;
	  
	  var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  	observerService.removeObserver(gGBSPOPObserver, "poped", false);
  	observerService.removeObserver(gGBSPOPObserver, "pop-failed", false);

	  var pref =  Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefBranch);

	  var str = "";
	  var send = false;
	  if(aTopic == "poped"){
		  str = this.localeBundle.getString("getsend.getpass");
		  //goDoCommand(this.cmd);
		  send = true;
	  } else if (aTopic == "pop-failed") {
		  str = this.localeBundle.getString("getsend.getfail");
		  var sendOnErr = false;
		  try {
			  sendOnErr = pref.getBoolPref("gbs.send_on_err");
		  } catch(e) {
		  }
		  
		  //if (sendOnErr && this.cmd) goDoCommand(this.cmd);
		  if (sendOnErr && this.cmd) send = true;
	  }
	  
	  if  (send) {
	  	var me = this;
	  	var delay = 0;
	  	try {
	  		delay = pref.getIntPref("gbs.delay_sec");
	  	} catch(e) {
	  		delay = 0;
	  	}
	  	var func = function() {
	  		goDoCommand(me.cmd);
		  	me.owner.updateDisp("init", str);
		  	me.ids = null;
	  	}
	  	setTimeout(func, delay*1000);
	  } else {
	  	this.owner.updateDisp("init", str);
	  	this.ids = null;
	  }
  }
}

function initGBS()
{
	gGBSSendMgr = new GBSSendManager(gGBSPOPObserver);
}
window.addEventListener("load",initGBS,false);

function GBSSendManager(observer)
{
	this.observer = observer;
	this.observer.register(this);
	this.localeBundle = document.getElementById("GBSBundle");
	this.observer.localeBundle = document.getElementById("GBSBundle");
	this.accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
	  .getService(Components.interfaces.nsIMsgAccountManager);
	this.smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"]
	  .getService(Components.interfaces.nsISmtpService);
	//Keyboard shortcut
	var def_skey = "VK_RETURN";
	var def_mod = [false, false, false, false, true]; //[accel, alt, ctrl, meta, shift]
	this.setShortcutKey("key_getsend","gbs.",def_skey,def_mod);
}

GBSSendManager.prototype.setShortcutKey = function(keyId, prefix, def_skey, def_mod)
{
	var modifiers = new Array();
	var pref =  Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	try {
		if (pref.getBoolPref(prefix + 'accel_key'))
		  modifiers.push('accel');
	} catch(e) {
		if (def_mod[0]) modifiers.push('accel');
	}

	try {
		if (pref.getBoolPref(prefix + 'alt_key'))
		  modifiers.push('alt');
	} catch(e) {
		if (def_mod[1]) modifiers.push('alt');
	}

	try {
		if (pref.getBoolPref(prefix + 'ctrl_key'))
		  modifiers.push('control');
	} catch(e) {
		if (def_mod[2]) modifiers.push('control');
	}

	try {
		if (pref.getBoolPref(prefix + 'meta_key'))
		  modifiers.push('meta');
	} catch(e) {
		if (def_mod[3]) modifiers.push('meta');
	}

	try {
		if (pref.getBoolPref(prefix + 'shift_key'))
		  modifiers.push('shift');
	} catch(e) {
		if (def_mod[4]) modifiers.push('shift');
	}

	var modifierString = null;
	if (modifiers.length > 0 ) modifierString = modifiers.join(' ');

	var skey;
	try {
		skey = pref.getCharPref(prefix + 'key');
	} catch(e) {
		skey = def_skey;
	}

	if (modifierString)
	  document.getElementById(keyId).setAttribute('modifiers', modifierString);
	var keyAttr = 'key';
	if (skey.indexOf("VK_") == 0) keyAttr = 'keycode';
	document.getElementById(keyId).setAttribute(keyAttr, skey);
}

GBSSendManager.prototype.send = function(aEvent, cmd)
{
	if (document.getElementById("menu-get-send-now").getAttribute("disabled") == "true") {
		this.observer.cmd = null;
		this.cancelSend();
	} else {
		var idOrAccount;
		this.observer.cmd = cmd;
		if (aEvent && aEvent.target.value) { //Get mails for Account
			idOrAccount = aEvent.target.value;
		} else { //Get mails for Identity
			idOrAccount = document.getElementById("msgIdentity").value;
			var authAccount = this.getAuthIncomingServerAccount(idOrAccount);
			switch (authAccount) {
				case "none": goDoCommand(cmd); return;
				case "default": break; //Use ID
				default: idOrAccount = authAccount; break; //Use predefined account
			}
		}
		var str = this.localeBundle.getString("getsend.getting");
		this.updateDisp("get", str);

		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(gGBSPOPObserver, "poped", false);
		observerService.addObserver(gGBSPOPObserver, "pop-failed", false);

		var date = new Date();
		var timeId = (date.getTime()).toString();
		this.observer.ids = timeId + "." + idOrAccount;
		observerService.notifyObservers(null, "get-before-send", this.observer.ids);
	}
}

GBSSendManager.prototype.getAuthIncomingServerAccount = function(idKey)
{
	var id = this.accountManager.getIdentity(idKey);
	var smtpServerKey = id.smtpServerKey;
	if (smtpServerKey == "")
	  smtpServerKey = this.smtpService.defaultServer.key;

	var prefString = "mail.smtpserver."+smtpServerKey+".gbs_inserver";
	var accountKey = nsPreferences.copyUnicharPref(prefString,"default");
	if (accountKey == "") accountKey = "default";

	return accountKey;
}

GBSSendManager.prototype.cancelSend = function()
{
	if (!(this.observer.ids)) return;
	
	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	observerService.removeObserver(gGBSPOPObserver, "poped", false);
	observerService.removeObserver(gGBSPOPObserver, "pop-failed", false);

	var str = this.localeBundle.getString("getsend.messengerstatus_canceled");
	this.updateDisp("init", str);
}

GBSSendManager.prototype.updateDisp = function(stat, str)
{
	document.getElementById("statusText").setAttribute("label",str);
	if (stat == "init") {
		document.getElementById("menu-get-send-now").setAttribute("disabled","false");
		document.getElementById("menu-get-send-stop").setAttribute("disabled","true");
		document.getElementById("msgIdentity").setAttribute("disabled","false");
	} else if (stat == "get") {
		document.getElementById("menu-get-send-now").setAttribute("disabled","true");
		document.getElementById("menu-get-send-stop").setAttribute("disabled","false");
		document.getElementById("msgIdentity").setAttribute("disabled","true");
	}
	
	var gbsButton = document.getElementById("button-getsend");
	if (gbsButton) {
		gbsButton.setAttribute("stat",stat);
	}
}



