var gGBSSettings = null;

function init()
{
	gGBSSettings = new GBSSettings();
	gGBSSettings.onLoad();
}
window.addEventListener("load", init, false);

function GBSSettings()
{
	this.acceptKeyChange = null; //id of button that accepts input
	this.localeBundle = document.getElementById("localeBundle");
	this.closeDlg = true;
	this.smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
	
	this.elementIDsOrg = [
		"GBSChkOnly",
		"GBSOnErr",
		"GBSDelay",
		"shortcut_key",
		"shortcut-modifier-accel",
		"shortcut-modifier-alt",
		"shortcut-modifier-ctrl",
		"shortcut-modifier-meta",
		"shortcut-modifier-shift",
		"shortcut-unsent_key",
		"shortcut-unsent-modifier-accel",
		"shortcut-unsent-modifier-alt",
		"shortcut-unsent-modifier-ctrl",
		"shortcut-unsent-modifier-meta",
		"shortcut-unsent-modifier-shift"
	];
	
	this.serverRowIDs;	
}

GBSSettings.prototype.savePrefs = function() {
	if (!this.closeDlg){
		this.closeDlg = true;
		return false;
	}

	if (this.acceptKeyChange) this.cancelKeyChange(null);
	var pref =  Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var elementIDs = this.elementIDsOrg.concat(this.serverRowIDs);
	for( var i = 0; i < elementIDs.length; i++ ) {
		var elementID = elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;
		if (eltType == "radiogroup")
		  pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
		else if (eltType == "checkbox")
		  pref.setBoolPref(element.getAttribute("prefstring"), element.checked);
		else if (eltType == "textbox" && element.getAttribute("preftype") == "int") {
		  pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value) );
		}
		else if (eltType == "textbox")
		  pref.setCharPref(element.getAttribute("prefstring"), element.value);
		else if (eltType == "menulist")
		  pref.setIntPref(element.getAttribute("prefstring"), element.selectedIndex);
		else if (eltType == "label")
		  pref.setCharPref(element.getAttribute("prefstring"), element.getAttribute("skey"));
		else if (eltType == "listitem"){
			pref.setCharPref(element.getAttribute("prefstring"), element.value);
		}
	}

	return true;
}

GBSSettings.prototype.cancelPrefs = function()
{
	if (this.closeDlg) return true;
	else {
		this.closeDlg = true;
		return false;
	}
}

GBSSettings.prototype.onLoad = function()
{
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	this.initAccountPopup();
	this.serverRowIDs = this.initSMTPServerTable();
	// initialize the default window values...
	var elementIDs = this.elementIDsOrg.concat(this.serverRowIDs);
	for( var i = 0; i < elementIDs.length; i++ ) {
		var elementID = elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;

		if (eltType == "radiogroup") {
			try {
				element.selectedItem = element.childNodes[pref.getIntPref(element.getAttribute("prefstring"))];
			} catch(e) {
				element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
				try {
					pref.setIntPref( element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
				} catch (e) {}
			}
		} else if (eltType == "checkbox") {
			try {
				element.checked = ( pref.getBoolPref(element.getAttribute("prefstring")) == true );
			} catch(e) {
				element.checked = ( element.getAttribute("defaultpref") == "true" );
				try {
					pref.setBoolPref( element.getAttribute("prefstring"), element.checked );
				} catch(e){}
			}
		} else if (eltType == "textbox") {
			try {
				var val = element.getAttribute("preftype") == "int" ?
						pref.getIntPref(element.getAttribute("prefstring")).toString() :
						pref.getCharPref(element.getAttribute("prefstring"));
				element.value = val;
			} catch(e) {
				element.setAttribute("value", element.getAttribute("defaultpref") );
			}
		} else if (eltType == "menulist") {
			try {
				element.selectedIndex = pref.getIntPref(element.getAttribute("prefstring"));
			} catch(e) {
				element.selectedIndex = element.getAttribute("defaultpref");
				try {
					pref.setIntPref( element.getAttribute("prefstring"), element.selectedIndex );
				} catch (e) {}
			}
		} else if (eltType == "label") {
			try {
				this.setLabel(element, pref.getCharPref(element.getAttribute("prefstring")));
				element.setAttribute("skey", pref.getCharPref(element.getAttribute("prefstring")) );
			} catch(e) {
				this.setLabel(element, element.getAttribute("defaultpref"));
				element.setAttribute("skey", element.getAttribute("defaultpref") );
				try {
					pref.setCharPref( element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
				} catch(e){}
			}
		} else if (eltType == "listitem") {
			var val;
			try {
				val = pref.getCharPref(element.getAttribute("prefstring"));
			} catch(e) {
				val = element.getAttribute("defaultpref");
				try {
					pref.setCharPref( element.getAttribute("prefstring"), val );
				} catch (e) {}
			}
			element.setAttribute("value", val);
			this.selectAccountInList(element,val);
		}
	}
	this.initDisabled();
}

GBSSettings.prototype.initDefault = function(elemIDs)
{
	// initialize the default window values...
	for( var i = 0; i < elemIDs.length; i++ ) {
		var elementID = elemIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;

		if (eltType == "radiogroup") {
			element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
		} else if (eltType == "checkbox") {
			element.checked = ( element.getAttribute("defaultpref") == "true" );
		} else if (eltType == "textbox") {
			element.value = element.getAttribute("defaultpref");
		} else if (eltType == "menulist") {
			element.selectedIndex = element.getAttribute("defaultpref");
		} else if (eltType == "label") {
			this.setLabel(element, element.getAttribute("defaultpref"));
			element.setAttribute("skey", element.getAttribute("defaultpref") );
		} else if (eltType == "listitem") {
			element.setAttribute("value", element.getAttribute("defaultpref"));
			this.selectAccountInList(element,element.getAttribute("defaultpref"));
		}
	}
}

GBSSettings.prototype.setDefaultGen = function()
{
	var elemIDs = [
		"GBSChkOnly",
		"GBSOnErr",
		"GBSDelay"
	];

	this.initDefault(elemIDs);
}

GBSSettings.prototype.setDefaultSMTP = function()
{
	this.initDefault(this.serverRowIDs);
}

GBSSettings.prototype.setDefaultSkey = function()
{
	var elemIDs = [
		"shortcut_key",
		"shortcut-modifier-accel",
		"shortcut-modifier-alt",
		"shortcut-modifier-ctrl",
		"shortcut-modifier-meta",
		"shortcut-modifier-shift",
		"shortcut-unsent_key",
		"shortcut-unsent-modifier-accel",
		"shortcut-unsent-modifier-alt",
		"shortcut-unsent-modifier-ctrl",
		"shortcut-unsent-modifier-meta",
		"shortcut-unsent-modifier-shift"
	];
	this.initDefault(elemIDs);
}

//If aEvent == null then cancel key change
GBSSettings.prototype.controlKeyChange = function(aEvent)
{

	var buttonStr1 = this.localeBundle.getString("gbsset.chkey");
	var buttonStr2 = this.localeBundle.getString("gbsset.skey_cancel");
	var prompt = this.localeBundle.getString("gbsset.skey_prompt");
	var changeButton;
	var promptLabel;
	var buttonId = null;

	if (!aEvent) buttonId = this.acceptKeyChange;
	else buttonId = aEvent.originalTarget.getAttribute("id");
		
	if (buttonId == "change_key") {
		changeButton = document.getElementById("change_key");
		promptLabel = document.getElementById("shortcut_key");
	} else if (buttonId == "change_unsent_key") {
		changeButton = document.getElementById("change_unsent_key");
		promptLabel = document.getElementById("shortcut-unsent_key");
	} else {
		return;
	}
	
	if (!this.acceptKeyChange) {
		changeButton.setAttribute("label", buttonStr2);
		this.acceptKeyChange = changeButton.getAttribute("id");
		promptLabel.setAttribute("value", prompt);
	} else {
		changeButton.setAttribute("label", buttonStr1);
		this.acceptKeyChange = null;
		var skey = promptLabel.getAttribute("skey");
		this.setLabel(promptLabel, skey);
	}
}

GBSSettings.prototype.cancelKeyChange = function(aEvent)
{
	if (this.acceptKeyChange != null) this.controlKeyChange(aEvent);
}

GBSSettings.prototype.changeKey = function(aEvent)
{
	aEvent.preventBubble();
	if (!this.acceptKeyChange) return;

	var promptLabel;
	if (aEvent.originalTarget.getAttribute("id") == "change_key") {
		promptLabel = document.getElementById("shortcut_key");		
	} else if (aEvent.originalTarget.getAttribute("id") == "change_unsent_key") {
		promptLabel = document.getElementById("shortcut-unsent_key");
	} else {
		//illegal event
		return;
	}

	if (aEvent.keyCode != 0) {
		var keystr = this.keyCodeToVK(aEvent);
		if (keystr != null)
		  promptLabel.setAttribute("skey",keystr);
		else return;
	} else {
		promptLabel.setAttribute("skey",String.fromCharCode(aEvent.which).toUpperCase());
	}
	
	this.controlKeyChange(aEvent);
}

GBSSettings.prototype.setLabel = function(label, str)
{
	switch (str) {
	  case " ":
		label.setAttribute("value","SPACE");
		break;
	  default:
		var substr = null;
		var i = str.indexOf("VK_");
		if (i != -1) substr = str.substring(i+3, str.length);
		else substr = str;
		label.setAttribute("value",substr);
	}
}

GBSSettings.prototype.keyCodeToVK = function(event)
{
	var keyStr;
	switch (event.keyCode) {
	  case event.DOM_VK_CANCEL:		keyStr = "VK_CANCEL"; break;
	  case event.DOM_VK_HELP:		keyStr = "VK_HELP"; break;
	  case event.DOM_VK_BACK_SPACE:	keyStr = "VK_BACK_SPACE"; break;
	  case event.DOM_VK_TAB:		keyStr = "VK_TAB"; break;
	  case event.DOM_VK_CLEAR:		keyStr = "VK_CLEAR"; break;
	  case event.DOM_VK_RETURN:		keyStr = "VK_RETURN"; break;
	  case event.DOM_VK_ENTER:		keyStr = "VK_ENTER"; break;
	  case event.DOM_VK_PAUSE:		keyStr = "VK_PAUSE"; break;
	  case event.DOM_VK_CAPS_LOCK:	keyStr = "VK_CAPS_LOCK"; break;
	  case event.DOM_VK_ESCAPE:		keyStr = "VK_ESCAPE"; this.closeDlg = false; break;
	  case event.DOM_VK_PAGE_UP:	keyStr = "VK_PAGE_UP"; break;
	  case event.DOM_VK_PAGE_DOWN:	keyStr = "VK_PAGE_DOWN"; break;
	  case event.DOM_VK_END:		keyStr = "VK_END"; break;
	  case event.DOM_VK_HOME:		keyStr = "VK_HOME"; break;
	  case event.DOM_VK_LEFT:		keyStr = "VK_LEFT"; break;
	  case event.DOM_VK_UP:			keyStr = "VK_UP"; break;
	  case event.DOM_VK_RIGHT:		keyStr = "VK_RIGHT"; break;
	  case event.DOM_VK_DOWN:		keyStr = "VK_DOWN"; break;
	  case event.DOM_VK_PRINTSCREEN: keyStr = "VK_PRINTSCREEN"; break;
	  case event.DOM_VK_INSERT:		keyStr = "VK_INSERT"; break;
	  case event.DOM_VK_DELETE:		keyStr = "VK_DELETE"; break;
	  case event.DOM_VK_F1:			keyStr = "VK_F1"; break;
	  case event.DOM_VK_F2:			keyStr = "VK_F2"; break;
	  case event.DOM_VK_F3:			keyStr = "VK_F3"; break;
	  case event.DOM_VK_F4:			keyStr = "VK_F4"; break;
	  case event.DOM_VK_F5:			keyStr = "VK_F5"; break;
	  case event.DOM_VK_F6:			keyStr = "VK_F6"; break;
	  case event.DOM_VK_F7:			keyStr = "VK_F7"; break;
	  case event.DOM_VK_F8:			keyStr = "VK_F8"; break;
	  case event.DOM_VK_F9:			keyStr = "VK_F9"; break;
	  case event.DOM_VK_F10:		keyStr = "VK_F10"; break;
	  case event.DOM_VK_F11:		keyStr = "VK_F11"; break;
	  case event.DOM_VK_F12:		keyStr = "VK_F12"; break;
	  case event.DOM_VK_F13:		keyStr = "VK_F13"; break;
	  case event.DOM_VK_F14:		keyStr = "VK_F14"; break;
	  case event.DOM_VK_F15:		keyStr = "VK_F15"; break;
	  case event.DOM_VK_F16:		keyStr = "VK_F16"; break;
	  case event.DOM_VK_F17:		keyStr = "VK_F17"; break;
	  case event.DOM_VK_F18:		keyStr = "VK_F18"; break;
	  case event.DOM_VK_F19:		keyStr = "VK_F19"; break;
	  case event.DOM_VK_F20:		keyStr = "VK_F20"; break;
	  case event.DOM_VK_F21:		keyStr = "VK_F21"; break;
	  case event.DOM_VK_F22:		keyStr = "VK_F22"; break;
	  case event.DOM_VK_F23:		keyStr = "VK_F23"; break;
	  case event.DOM_VK_F24:		keyStr = "VK_F24"; break;
	  case event.DOM_VK_NUM_LOCK:	keyStr = "VK_NUM_LOCK"; break;
	  case event.DOM_VK_SCROLL_LOCK: keyStr = "VK_SCROLL_LOCK";	break;
	  default:						keyStr = null; break;
	}
	return keyStr;
}

GBSSettings.prototype.initAccountPopup = function()
{
	var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
	var allServers = accountManager.allServers;
	var serverCount = allServers.Count();
	var popup = document.getElementById("pop_menupopup");
	var serverCount = allServers.Count();
	for (var i = 0; i < serverCount; i++) {
		var server = allServers.QueryElementAt(i, Components.interfaces. nsIMsgIncomingServer);
		if (server.type == "nntp" || server.type == "rss" || server.type == "none") continue;
		var accountName = server.prettyName;
		var account = accountManager.FindAccountForServer(server);
		var accountKey = account.key;
		var item = document.createElement("menuitem");
		item.setAttribute("label",accountName);
		item.setAttribute("value",accountKey);
		popup.appendChild(item);
	}
	return;
}

GBSSettings.prototype.initSMTPServerTable = function()
{
	var defaultServer = this.smtpService.defaultServer;
	var rowIds = this.fillSmtpServersTable(this.smtpService.smtpServers, defaultServer);
	return rowIds;
}

GBSSettings.prototype.fillSmtpServersTable = function(aServers, aDefaultServer)
{
	var table = document.getElementById("servers_table");
	var rows = new Array();
	
	while (aServers.hasMoreElements()) {
  	var server = aServers.getNext().QueryInterface(Components.interfaces.nsISmtpServer);
	  var isDefault = (aDefaultServer.key == server.key);
	  //ToDoList: add code that allows for the redirector type to specify whether to show values or not
	  if (!server.redirectorType)
		{
			var row = this.createSmtpRow(server, isDefault);
			table.appendChild(row);
			rows.push(row.id);
		}
  }

	//remove skelton item
	table.removeItemAt(0);

	return rows;
}

GBSSettings.prototype.createSmtpRow = function(aServer, aIsDefault)
{
	var skel = document.getElementById("dummy_row");
	var newRow = skel.cloneNode(true);
	newRow.setAttribute("id","row_" + aServer.key);
	newRow.setAttribute("hidden","false");
	var newCell = newRow.firstChild;
	newCell.setAttribute("id","cell_" + aServer.key);
	var serverName = "";

	if (aServer.description)
	  serverName = aServer.description + ' - ';
	else if (aServer.username)
	  serverName = aServer.username + ' - ';

	serverName += aServer.hostname;

	if (aIsDefault)
	  serverName += " " + "(Default)";

	newCell.setAttribute("label", serverName);
	newCell.setAttribute("tooltiptext", serverName);
	newRow.setAttribute("prefstring", "mail.smtpserver."+aServer.key+".gbs_inserver");
	newRow.setAttribute("defaultpref", "default");

	return newRow;
}

GBSSettings.prototype.incomingServerChanged = function(aEvent)
{
	var menuitem = aEvent.target;
	var menupopup = menuitem.parentNode;
	var menulist = menupopup.parentNode;
	var listcell = menulist.parentNode;
	var listitem = listcell.parentNode;

	var val = menuitem.getAttribute("value");
	listitem.setAttribute("value",val);
}

GBSSettings.prototype.selectAccountInList = function(listitem,val)
{
	var listcell = listitem.lastChild;
	var menulist = listcell.firstChild;
	var menupopup = menulist.firstChild;

	var menuitems = menupopup.childNodes;

	for (var i=0; i<menuitems.length; i++) {
		var menuitem = menuitems[i];
		if (menuitem.getAttribute("value") == val) {
			menulist.selectedItem = menuitem;
			break;
		}
	}

	return;
}

GBSSettings.prototype.verifyTextBoxForNum = function(target)
{
	var num = parseInt(target.value);
	if (isNaN(num) || num < 0) target.value = 0;
	else target.value = num.toString();
}